require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_LINUX_AUTO_FS_H)) {
    eval 'sub _LINUX_AUTO_FS_H () {1;}' unless defined(&_LINUX_AUTO_FS_H);
    require 'linux/types.ph';
    require 'linux/limits.ph';
    require 'sys/ioctl.ph';
    eval 'sub AUTOFS_PROTO_VERSION () {5;}' unless defined(&AUTOFS_PROTO_VERSION);
    eval 'sub AUTOFS_MIN_PROTO_VERSION () {3;}' unless defined(&AUTOFS_MIN_PROTO_VERSION);
    eval 'sub AUTOFS_MAX_PROTO_VERSION () {5;}' unless defined(&AUTOFS_MAX_PROTO_VERSION);
    eval 'sub AUTOFS_PROTO_SUBVERSION () {6;}' unless defined(&AUTOFS_PROTO_SUBVERSION);
    if(defined(&__ia64__) || defined(&__alpha__) ) {
    } else {
    }
    eval 'sub autofs_ptype_missing () {0;}' unless defined(&autofs_ptype_missing);
    eval 'sub autofs_ptype_expire () {1;}' unless defined(&autofs_ptype_expire);
    eval 'sub AUTOFS_IOCTL () {0x93;}' unless defined(&AUTOFS_IOCTL);
    eval("sub AUTOFS_IOC_READY_CMD () { 0x60; }") unless defined(&AUTOFS_IOC_READY_CMD);
    eval("sub AUTOFS_IOC_FAIL_CMD () { 1; }") unless defined(&AUTOFS_IOC_FAIL_CMD);
    eval("sub AUTOFS_IOC_CATATONIC_CMD () { 2; }") unless defined(&AUTOFS_IOC_CATATONIC_CMD);
    eval("sub AUTOFS_IOC_PROTOVER_CMD () { 3; }") unless defined(&AUTOFS_IOC_PROTOVER_CMD);
    eval("sub AUTOFS_IOC_SETTIMEOUT_CMD () { 4; }") unless defined(&AUTOFS_IOC_SETTIMEOUT_CMD);
    eval("sub AUTOFS_IOC_EXPIRE_CMD () { 5; }") unless defined(&AUTOFS_IOC_EXPIRE_CMD);
    eval 'sub AUTOFS_IOC_READY () { &_IO( &AUTOFS_IOCTL,  &AUTOFS_IOC_READY_CMD);}' unless defined(&AUTOFS_IOC_READY);
    eval 'sub AUTOFS_IOC_FAIL () { &_IO( &AUTOFS_IOCTL,  &AUTOFS_IOC_FAIL_CMD);}' unless defined(&AUTOFS_IOC_FAIL);
    eval 'sub AUTOFS_IOC_CATATONIC () { &_IO( &AUTOFS_IOCTL,  &AUTOFS_IOC_CATATONIC_CMD);}' unless defined(&AUTOFS_IOC_CATATONIC);
    eval 'sub AUTOFS_IOC_PROTOVER () { &_IOR( &AUTOFS_IOCTL,  &AUTOFS_IOC_PROTOVER_CMD, \'int\');}' unless defined(&AUTOFS_IOC_PROTOVER);
    eval 'sub AUTOFS_IOC_SETTIMEOUT32 () { &_IOWR( &AUTOFS_IOCTL,  &AUTOFS_IOC_SETTIMEOUT_CMD, \'compat_ulong_t\');}' unless defined(&AUTOFS_IOC_SETTIMEOUT32);
    eval 'sub AUTOFS_IOC_SETTIMEOUT () { &_IOWR( &AUTOFS_IOCTL,  &AUTOFS_IOC_SETTIMEOUT_CMD, \'unsigned long\');}' unless defined(&AUTOFS_IOC_SETTIMEOUT);
    eval 'sub AUTOFS_IOC_EXPIRE () { &_IOR( &AUTOFS_IOCTL,  &AUTOFS_IOC_EXPIRE_CMD, \'struct autofs_packet_expire\');}' unless defined(&AUTOFS_IOC_EXPIRE);
    eval 'sub AUTOFS_EXP_NORMAL () {0x;}' unless defined(&AUTOFS_EXP_NORMAL);
    eval 'sub AUTOFS_EXP_IMMEDIATE () {0x1;}' unless defined(&AUTOFS_EXP_IMMEDIATE);
    eval 'sub AUTOFS_EXP_LEAVES () {0x2;}' unless defined(&AUTOFS_EXP_LEAVES);
    eval 'sub AUTOFS_EXP_FORCED () {0x4;}' unless defined(&AUTOFS_EXP_FORCED);
    eval 'sub AUTOFS_TYPE_ANY () {0;}' unless defined(&AUTOFS_TYPE_ANY);
    eval 'sub AUTOFS_TYPE_INDIRECT () {1;}' unless defined(&AUTOFS_TYPE_INDIRECT);
    eval 'sub AUTOFS_TYPE_DIRECT () {2;}' unless defined(&AUTOFS_TYPE_DIRECT);
    eval 'sub AUTOFS_TYPE_OFFSET () {4;}' unless defined(&AUTOFS_TYPE_OFFSET);
    eval 'sub set_autofs_type_indirect {
        my($type) = @_;
	    eval q({ *$type =  &AUTOFS_TYPE_INDIRECT; });
    }' unless defined(&set_autofs_type_indirect);
    eval 'sub autofs_type_indirect {
        my($type) = @_;
	    eval q({ ($type ==  &AUTOFS_TYPE_INDIRECT); });
    }' unless defined(&autofs_type_indirect);
    eval 'sub set_autofs_type_direct {
        my($type) = @_;
	    eval q({ *$type =  &AUTOFS_TYPE_DIRECT; });
    }' unless defined(&set_autofs_type_direct);
    eval 'sub autofs_type_direct {
        my($type) = @_;
	    eval q({ ($type ==  &AUTOFS_TYPE_DIRECT); });
    }' unless defined(&autofs_type_direct);
    eval 'sub set_autofs_type_offset {
        my($type) = @_;
	    eval q({ *$type =  &AUTOFS_TYPE_OFFSET; });
    }' unless defined(&set_autofs_type_offset);
    eval 'sub autofs_type_offset {
        my($type) = @_;
	    eval q({ ($type ==  &AUTOFS_TYPE_OFFSET); });
    }' unless defined(&autofs_type_offset);
    eval 'sub autofs_type_trigger {
        my($type) = @_;
	    eval q({ ($type ==  &AUTOFS_TYPE_DIRECT || $type ==  &AUTOFS_TYPE_OFFSET); });
    }' unless defined(&autofs_type_trigger);
    eval 'sub autofs_type_any {
        my($type) = @_;
	    eval q({ ($type ==  &AUTOFS_TYPE_ANY); });
    }' unless defined(&autofs_type_any);
    eval("sub NFY_NONE () { 0; }") unless defined(&NFY_NONE);
    eval("sub NFY_MOUNT () { 1; }") unless defined(&NFY_MOUNT);
    eval("sub NFY_EXPIRE () { 2; }") unless defined(&NFY_EXPIRE);
    eval 'sub autofs_ptype_expire_multi () {2;}' unless defined(&autofs_ptype_expire_multi);
    eval 'sub autofs_ptype_missing_indirect () {3;}' unless defined(&autofs_ptype_missing_indirect);
    eval 'sub autofs_ptype_expire_indirect () {4;}' unless defined(&autofs_ptype_expire_indirect);
    eval 'sub autofs_ptype_missing_direct () {5;}' unless defined(&autofs_ptype_missing_direct);
    eval 'sub autofs_ptype_expire_direct () {6;}' unless defined(&autofs_ptype_expire_direct);
    eval("sub AUTOFS_IOC_EXPIRE_MULTI_CMD () { 0x66; }") unless defined(&AUTOFS_IOC_EXPIRE_MULTI_CMD);
    eval("sub AUTOFS_IOC_PROTOSUBVER_CMD () { 1; }") unless defined(&AUTOFS_IOC_PROTOSUBVER_CMD);
    eval("sub AUTOFS_IOC_ASKUMOUNT_CMD () { 0x70; }") unless defined(&AUTOFS_IOC_ASKUMOUNT_CMD);
    eval 'sub AUTOFS_IOC_EXPIRE_MULTI () { &_IOW( &AUTOFS_IOCTL,  &AUTOFS_IOC_EXPIRE_MULTI_CMD, \'int\');}' unless defined(&AUTOFS_IOC_EXPIRE_MULTI);
    eval 'sub AUTOFS_IOC_PROTOSUBVER () { &_IOR( &AUTOFS_IOCTL,  &AUTOFS_IOC_PROTOSUBVER_CMD, \'int\');}' unless defined(&AUTOFS_IOC_PROTOSUBVER);
    eval 'sub AUTOFS_IOC_ASKUMOUNT () { &_IOR( &AUTOFS_IOCTL,  &AUTOFS_IOC_ASKUMOUNT_CMD, \'int\');}' unless defined(&AUTOFS_IOC_ASKUMOUNT);
}
1;
